import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter_easyrefresh/easy_refresh.dart';
import 'message_item.dart';
import 'package:dio/dio.dart';
import 'package:flutter/semantics.dart';
import 'package:gmalpha_flutter/model/message/message.dart';
import 'package:gmalpha_flutter/netWork/DioUtil.dart';
import 'package:gmalpha_flutter/toast/toast.dart';

class MessageHomePage extends StatefulWidget {
  @override
  _MessageHomePageState createState() => _MessageHomePageState();
}

class _MessageHomePageState extends State<MessageHomePage> with AutomaticKeepAliveClientMixin {

  List<Message> messageList = List<Message>();
  // List<Map> commentsList=[{'name': 'Burial', 'icon': 'http://alpha-s.gmeiapp.com/2018/12/23/921d3a004e-w', 'time': '1.560856220460315E9', 'content':'卖萌打滚求翻牌', 'replied_content': {'content': 'http://alpha.iyanzhi.com/2019/06/18/1833/5f4c9dd92dc7-thumb'}},
  //                         {'name': '거짓말 ', 'icon': 'http://alpha-s.gmeiapp.com/2018/12/23/8179d48c63-w', 'time': '1.560856220460315E9', 'content':'小姐姐，作图app是啥', 'replied_content': {'content': 'http://alpha.iyanzhi.com/2019/06/18/1833/5f4c9dd92dc7-thumb'}},
  //                         {'name': 'blugder ', 'icon': 'http://alpha-s.gmeiapp.com/2018/12/23/8179d48c63-w', 'time': '1.560856220460315E9', 'content':'拍照表情很自然', 'replied_content': {'content': 'http://alpha.iyanzhi.com/2019/06/18/1833/5f4c9dd92dc7-thumb'}},
  //                         ];

  // GlobalKey<EasyRefreshState> _easyRefreshKey =new GlobalKey<EasyRefreshState>();
  // GlobalKey<RefreshFooterState> _footerKey = new GlobalKey<RefreshFooterState>();
  @override
  bool get wantKeepAlive => true;

  Future<List<Message>> _fetchMesssageList() async {
    BaseOptions options = DioUtil.getDefOptions();
    Map<String, dynamic> cookie = {'cookie': '_gm_token=4cabd51562739648; _gtid=fac513b6a2bf11e9acfd525400e5c7a38141; sessionid=7j7s902fmro0pvybwrp374khvva6l3xf;'};
    HttpConfig config = new HttpConfig(options: options, nativeCookie:cookie);
    DioUtil().setConfig(config);
    List<Message> messageList = List<Message>();
    print('aaaaa');
    BaseResp<List> baseresp = await DioUtil().request<List>(Method.get, "api/v1/reply/my", queryParameters: {'page': 1, 'count': 10});
    if (baseresp.code != 0) {
      return new Future.error(baseresp.msg);
    }
    
    if (baseresp.data != null) {
      messageList = baseresp.data.map((value) {
        return Message.fromJson(value);
      }).toList();
    }
    return messageList;
  }

  @override
  Widget build(BuildContext context) {
    return new Scaffold(
      appBar: new AppBar(
        title: new Text('消息'),
      ),
      floatingActionButton: new FloatingActionButton(
          onPressed: () {
          },
          child: new Icon(Icons.add_box),
          elevation: 3.0,
          highlightElevation: 2.0,
          backgroundColor: Colors.red,        // 红色
        ),
      // body: ListView(children: _getListData()),
      
      body: new Center(
        child: FutureBuilder(
        future: _fetchMesssageList(),
        builder: (context, snapshot) {
          switch (snapshot.connectionState) {
            case ConnectionState.none:
            case ConnectionState.waiting:
              break;
            default:
             if (snapshot.hasData) {
                return _createListView(context, snapshot);
              }
          }
        },
      ),
      )
    );
  }
  

  Widget _createListView(BuildContext context, AsyncSnapshot snapshot) {
    List<Message> messageList = snapshot.data;
    return ListView.builder(
      shrinkWrap: true,
      key: new PageStorageKey('message-list'),
      itemCount: messageList.length,
      itemBuilder: (BuildContext context, int index) {
        return new MessageItem(onPressed: (){}, message:messageList[index]);
      },
    );
  }

  }